import { JSX } from './jsx/jsx-namespace';
import Component from './component';
import { playerFrame } from './playerFrames';
import { IContext } from './types';
type playState = 'play' | 'pause' | 'finish';
export interface PlayerProps {
    /**
     * 播放状态
     */
    state?: playState;
    /**
     * 播放速率，默认为 1
     */
    children?: JSX.Element | null;
    keyFrames?: Record<string, playerFrame>[];
    /**
     * 协议动画播放结束
     */
    onend?: Function;
}
declare class Player extends Component<PlayerProps> {
    playerFrames: any;
    index: number;
    onend: Function;
    /**
    * 协议动画状态 play pause finish
    */
    isEnd: boolean;
    constructor(props: any);
    private setPlayState;
    willMount(): void;
    didMount(): void;
    willUpdate(): void;
    willReceiveProps(_nextProps: PlayerProps, _context?: IContext): void;
    next: () => void;
    animationWillPlay(): void;
    render(): any;
}
export default Player;
