import { isDisplayObject } from '@antv/g-lite';
import { isFunction } from '@antv/util';
import { createShape } from './createShape';
function applyStyle(shape, style) {
  if (!style) return;
  Object.keys(style).forEach(function (key) {
    // 特殊处理 clip 和 offset
    if (key === 'clip' || key === 'offset') {
      var effect = style[key];
      // value 为 ref
      if (isDisplayObject(effect === null || effect === void 0 ? void 0 : effect.current)) {
        shape.setAttribute("".concat(key, "Path"), effect.current);
        return;
      }
      var effectConfig = isFunction(effect) ? effect(style) : effect;
      if (effectConfig) {
        var type = effectConfig.type,
          style_1 = effectConfig.style;
        var effectShape = createShape(type, {
          style: style_1
        });
        shape.setAttribute("".concat(key, "Path"), effectShape);
      }
    } else {
      shape.setAttribute(key, style[key]);
    }
  });
}
export default applyStyle;