"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _gLite = require("@antv/g-lite");
var _util = require("@antv/util");
var _createShape = require("./createShape");
function applyStyle(shape, style) {
  if (!style) return;
  Object.keys(style).forEach(function (key) {
    // 特殊处理 clip 和 offset
    if (key === 'clip' || key === 'offset') {
      var effect = style[key];
      // value 为 ref
      if ((0, _gLite.isDisplayObject)(effect === null || effect === void 0 ? void 0 : effect.current)) {
        shape.setAttribute("".concat(key, "Path"), effect.current);
        return;
      }
      var effectConfig = (0, _util.isFunction)(effect) ? effect(style) : effect;
      if (effectConfig) {
        var type = effectConfig.type,
          style_1 = effectConfig.style;
        var effectShape = (0, _createShape.createShape)(type, {
          style: style_1
        });
        shape.setAttribute("".concat(key, "Path"), effectShape);
      }
    } else {
      shape.setAttribute(key, style[key]);
    }
  });
}
var _default = exports.default = applyStyle;